package VoE;

/* (k) 2005 by ahzf voe@ahzf.de */

import java.net.*;
import java.io.*;
import java.util.Vector;
import VoE.*;


public class VoE_TCPEchoServerThread extends VoE_EchoServerThread implements Runnable {


  private int				TCPEchoServerThreadCounter;
  private ServerSocket			serverSocket;
  private Socket			clientSocket;
  private VoE_TCPEchoServerThread2	echoThread;




  public VoE_TCPEchoServerThread(int counter, int port, String user) {

    super(counter, port, user, "TCP");

    try {
      System.out.println("child openSocket()");
      this.serverSocket = new ServerSocket(serverPort);
      System.out.println(serverProtocol+"EchoServer on port "+serverPort+" started");
    } catch (Exception e) {
      initError = true;
      System.out.println(serverProtocol+"EchoServer on port "+serverPort+" Exception during startup: "+e);
    }

  }




  public boolean isValid() {
    if (serverSocket == null || initError) {
      if (serverSocket == null) System.out.println(serverProtocol+"EchoServer1 on port "+serverPort+": serverSocket == null");
      if (initError)            System.out.println(serverProtocol+"EchoServer1 on port "+serverPort+": initError == true");
      return(false);
    } else {
      return(true);
    }
  }



  public void killServer() {
    try {
      if(serverSocket != null) serverSocket.close();
    } catch (Exception e) {
    }
  }




  public void run() {


    try{

      while(true){
        clientSocket	= serverSocket.accept();
        System.out.println(serverProtocol+"EchoServer on port "+serverPort+": new connection from "+clientSocket.getInetAddress()+", port "+clientSocket.getPort());
        echoThread	= new VoE_TCPEchoServerThread2(TCPEchoServerThreadCounter);
        echoThread.setSocket(clientSocket);
        (new Thread(echoThread, "TCPEchoThread2 #"+TCPEchoServerThreadCounter++)).start();
      }

    } catch (Exception e) {
      System.out.println(serverProtocol+"EchoServer on port "+serverPort+": " + e.getMessage());

    } finally {
      System.out.println(serverProtocol+"EchoServer on port "+serverPort+" finally stopped");
    }

    System.out.println(serverProtocol+"EchoServer on port "+serverPort+" stopped");

  }


}
