package VoE;

/* (k) 2005 by ahzf voe@ahzf.de */

import java.io.*;
import java.net.*;
import java.util.*;
import java.util.StringTokenizer;
import java.util.List;
import java.util.Iterator;
import java.util.Timer;
import java.util.HashMap;
import java.io.File;
import VoE.*;



class VoE_TCPEchoServerThread2 implements Runnable {

    final  static int    BUF_SIZE = 65000;
    static final  byte[] EOL      = {(byte)'\r', (byte)'\n' };

    /* buffer to use for requests */
    byte[]	clBuf;
    byte[]	srBuf;

    private	Socket			clSocket;
    
    private	DataOutputStream	clOneOut;
    private	BufferedReader		clOneIn;
    private	DataOutputStream	clTwoOut;
    private	BufferedReader		clTwoIn;

    private	int			sessionEntered	= 0;
    private	int			threadCounter;

    private	Vector			echoServers	= new Vector();




    VoE_TCPEchoServerThread2(int counter) {
      clBuf		= new byte[BUF_SIZE];
      srBuf		= new byte[BUF_SIZE];
      clSocket		= null;
      threadCounter	= counter;
//      Thread.setDaemon(true);
    }



    synchronized void setSocket(Socket clSocket) {

      this.clSocket = clSocket;

      try {
        clSocket.setSoTimeout(20000);
        clSocket.setTcpNoDelay(true);
        clSocket.setKeepAlive(true);
      } catch (SocketException e) {
        System.out.println("TCPEchoServerThread2 --> SetSocketError... "+e);
      }

      notify();

    }



    public synchronized void run() {

      String request = "";

      try {

        System.out.println("TCPEchoServerThread2 --> connection from "+clSocket.getInetAddress().getHostName()+":"+clSocket.getPort());

        InputStream clIn         = new BufferedInputStream(clSocket.getInputStream());
        PrintStream clOut        = new PrintStream(clSocket.getOutputStream());

        BufferedReader   clOneIn  = new BufferedReader(new InputStreamReader(clSocket.getInputStream()));
        DataOutputStream clOneOut = new DataOutputStream(clSocket.getOutputStream()); 

        clOneOut.writeBytes("\r\n");
        clOneOut.writeBytes("\\\\     /   \r\n");
        clOneOut.writeBytes(" \\\\   /     __ \r\n");
        clOneOut.writeBytes("  \\\\ / /-/ /_  Voice-over-Everything - TCP Echo Server v0.1 \r\n");
        clOneOut.writeBytes("   \\/ /_/ /__  ____________________________________________________ \r\n\r\n");
        clOneOut.writeBytes(" Your ip address/port: "+clSocket.getInetAddress().getHostAddress()+"/"+clSocket.getPort()+"\r\n\r\n");
        clOneOut.flush();

        do {

          try {
            request	= clOneIn.readLine();
            clOneOut.writeBytes("reply:"+request+":\n");
//            System.out.println(request);
          } catch (Exception e) {
//            System.out.println("fucking java bug in TCPEchoServer... "+e);
          }

//          int n;
//          while ((n = clIn.read(clBuf)) > 0) {
//            clOut.write(clBuf,0,n);
//            clOut.write(clBuf,0,n);
//          }

        } while (clSocket.isConnected() && !request.startsWith("quit"));

        System.out.println("TCP Thread("+threadCounter+")        \t--> closing connection to "+clSocket.getInetAddress().getHostAddress()+", port "+clSocket.getPort());
        clSocket.close();

      } catch (IOException e) {
        System.out.println("TCP Thread("+threadCounter+")        \t--> closing connection to "+clSocket.getInetAddress().getHostAddress()+", port "+clSocket.getPort()+" because of an IOException");
      }


    }

}

