package VoE;

/* (k) 2005 by ahzf voe@ahzf.de */

import java.net.*;
import java.io.*;
import java.util.Vector;
import VoE.*;


public class VoE_UDPEchoServerThread extends VoE_EchoServerThread implements Runnable {



  public VoE_UDPEchoServerThread(int counter, int port, String user) {

    super(counter, port, user, "UDP");

    try {
      System.out.println("child openSocket()");
      this.serverSocket = new DatagramSocket(this.serverPort);
      System.out.println(serverProtocol+"EchoServer on port "+serverPort+" started");
    } catch (SocketException e) {
      initError = true;
    }

  }



  public void run() {

    try{

      while(true){

        DatagramPacket request = new DatagramPacket(buffer, buffer.length);
        serverSocket.receive(request);

        DatagramPacket reply   = new DatagramPacket(request.getData(), request.getLength(), request.getAddress(), request.getPort() );
        serverSocket.send(reply);

      }

    } catch (Exception e) {
      System.out.println(serverProtocol+"EchoServer on port "+serverPort+": " + e.getMessage());

    } finally {
      if(serverSocket != null) serverSocket.close();
      System.out.println(serverProtocol+"EchoServer on port "+serverPort+" finally stopped");
    }

    System.out.println(serverProtocol+"EchoServer on port "+serverPort+" stopped");

  }


}
